//----------------------------------------------------------------------//
//									//
//	OS2 utility functions						//
//									//
//----------------------------------------------------------------------//

#ifndef	__ACPIDATA_H
#define	__ACPIDATA_H

extern UINT32			AcpiDbgLevel;
extern UINT32			AcpiDbgLayer;
extern UINT32			AcpiGbl_NestingLevel;

extern PSDSETUP		Setup;
extern PSDDEBUG		ACPIPSDDebug;
extern UINT32			ComPort;
extern UINT32			WakeupVectorPhys;
extern UINT32			WakeupVectorLin;
extern ULONG			IRQFlag;		// IRQ handled == 1, IRQ not handled == 0, reset in basedev
extern PMTimer		Work;			// PM Timer struct
extern UINT32			IdleFunction;
extern UINT32			MemAllocCounter;
extern UINT32	 		MemAllocAddr[];
extern UINT32			ShutDownFlag;
extern ULONG			GdtPhys;
extern ULONG			IdtPhys;
extern ULONG			GdtLin;
extern ULONG			DispEOI;

extern PAcpiIRQ		CurrentIRQ;                           // Current IRQ
extern PAcpiIRQ		OverrideIRQ;                          // Override IRQ
extern PIRQBus		SetIRQBus;                            // Pointer to override IRQ from command string
extern ULONG			IOAPICCount;                        // IO APIC count
extern PIOAPIC		MADTioAPIC;                           // Pointer to IO APIC
extern PPROCESSOR		Processor;                            // CPU in use
extern ULONG			ECCount;                            // Embedded controller count
extern EMMBEDDED_CONTROLLER	E_C[];                          // Get from ECDT struct and filling from _CRS PNP0C09
extern char			_CST[5];
extern P_F_2			router;
extern ULONG           	UsableCPU;
extern ULONG	       	CPUidToNumber[];
extern ULONG			C2Port;

extern ULONG			PowerButtonFlag;                       // For KernWakeUp
extern ULONG			SleepButtonFlag;                       // For KernWakeUp
extern ULONG			PowerButtonStatus;                     // Status install handler
extern ULONG			SleepButtonStatus;                     // Status install handler

extern ULONG			DeviceNotifyFlag;
extern ULONG			SystemNotifyFlag;
extern ULONG			DeviceNotifyStatus;
extern ULONG			SystemNotifyStatus;

extern ACPINotify		Device;
extern ACPINotify		System;
extern ACPINotify		GPE;
extern ACPINotify		Embedded;

extern UINT32			ECExeCounterToExe;
extern UINT32			ECExeCurrentExe;
extern PEvaluateName		ECExeQueue[];

extern UINT32			GPEExeCounterToExe;
extern UINT32			GPEExeCurrentExe;
extern PACPINotify		GPEExeQueue[];

extern UINT32               OSExecCounter;
extern UINT32               OSExeCurrent;
extern OSEXECUTE            OSExecute[];

extern UINT32			NotifyReceiveCounter;
extern UINT32			NotifyCurrentCounter;
extern EventNotify		NotifyQueue[];
extern ACPINotify		Notify;
extern PDriverNotify		DrvHead;
extern PDriverNotify		Drv;

extern ULONG                CPUExecCount;
extern CPUEXECUTE           CPUExecute[];  


extern ULONG			LocalApic;
extern ULONG			IOApic;
extern ULONG			IOApicId;
extern ULONG			UsableCPU;
extern ULONG			MADTisUSE;                   // For MADT > 1

extern ACPI_GENERIC_ADDRESS     ResetReg;
extern UINT32                   ResetValue;
extern ACPIEXPORTEDFUNCTION     AcpiExportedFunctions;
extern volatile UINT32 ExecuteLock;
// Execute Subrogram at all CPU
extern volatile ACPIRUNATALLCPU Execute;         // What execute
extern volatile void           *Context;         // Parameters for this
extern volatile UINT32          CPUMask;            // Here CPU will clear bit after execute
extern volatile UINT32          CPULock;         // Lock for access above data
extern volatile UINT32          ExeFlag;         // Flag for execute


ACPI_STATUS SetThrottlingOrCState(PTHROTTLING_C_STATE);	// For call API ACPI
ACPI_STATUS GetThrottlingOrCState(PTHROTTLING_C_STATE); // For call API ACPI

extern volatile UINT32	*APICLVADR;                    // Local APIC address
extern volatile UINT32	*APICIVADR;                    // IO Apic

extern UINT32	     	R3EmbdFlag;
extern UINT32 EventTreadFunction;

extern PKNOWNDEVICE FndDev;                     // For PSD service AcpiGetIRQForDevice
extern ULONG        FndDevCount;

extern char	OsName[];
extern char	OSIName[];

// Internal function
void	      Snooper(PSNOOPERPAR par);
ACPI_STATUS  GetNeedTable(void);
void	      SleepState(UINT32);
void         ECEvaluate(void *w);
void         GPEEvaluate(PACPINotify What);
void         ReallocDebugBuffer(unsigned char *NewBuf);
void         CheckEvent(void);
void         PIC1_EOI(void);
void         PIC2_EOI(void);
void         APIC_EOI(void);
void         IPIIRQ(void);
void         ERRIRQ(void);
void         SPURIRQ(void);
UINT32  APIENTRY DummyIRQ(void);
UINT32  APIENTRY PSDSIDT(UINT32 IdtrMy);
ACPI_STATUS APIENTRY FindPCIDevice(PKNOWNDEVICE f);

#endif


