;-----------------------------------------------------------------------;
;									;
; resource manager data structures					;
;									;
;-----------------------------------------------------------------------;

CMVERSION_MAJOR 	equ	1
CMVERSION_MINOR		equ	1


; driver structure

DRIVERSTRUCT	STRUC
DRS_DrvrName		DD	?
DRS_DrvrDescript	DD	?
DRS_VendorName		DD	?
DRS_MajorVer		DB	?
DRS_MinorVer		DB	?
DRS_DateYear		DW	?
DRS_DateMonth		DB	?
DRS_DateDay		DB	?
DRS_DrvrFlags		DW	?
DRS_DrvrType		DW	?
DRS_DrvrSubType		DW	?
DRS_DrvrCallback	DD	?
DRIVERSTRUCT	ENDS


; adapter structure

ADAPTERSTRUCT	STRUC
ADS_AdaptDescriptName	DD	?
ADS_AdaptFlags		DW	?
ADS_BaseType		DW	?
ADS_SubType		DW	?
ADS_InterfaceType	DW	?
ADS_HostBusType		DW	?
ADS_HostBusWidth	DW	?
ADS_pAdjunctList	DD	?
ADS_Reserved		DD	?
ADAPTERSTRUCT	ENDS


; device structure

DEVICESTRUCT	STRUC
DES_DevDescriptName	DD	?
DES_DevFlags		DW	?
DES_DevType		DW	?
DES_pAdjunctList	DD	?
DEVICESTRUCT	ENDS


; rm command codes

RMGETVERSION            equ	1
RMCREATEDRIVER          equ	2
RMDESTROYDRIVER         equ	3
RMCREATEADAPTER         equ	4
RMDESTROYADAPTER        equ	5
RMCREATEDEVICE          equ	6
RMDESTROYDEVICE         equ	7
RMALLOCRESOURCE         equ	8
RMDEALLOCRESOURCE       equ	9

; special handles

RMHANDLE_PHYS_TREE	equ	0ffff8000h
RMHANDLE_SYS_TREE	equ	0ffff8001h
RMHANDLE_DEFAULT_SYSBUS	equ	0ffff8002h
RMHANDLE_X_BUS		equ	0ffff8003h
RMHANDLE_PCI_BUS	equ	0ffff8004h
RMHANDLE_PREVIOUS_DETECTED equ	0ffff8005h
RMHANDLE_CURRENT_DETECTED  equ	0ffff8006h

; host bus types

RMAS_HOSTBUS_OTHER	equ	0
RMAS_HOSTBUS_ISA	equ	1
RMAS_HOSTBUS_EISA	equ	2
RMAS_HOSTBUS_uCHNL	equ	3
RMAS_HOSTBUS_PCI	equ	4
RMAS_HOSTBUS_SCSI	equ	5
RMAS_HOSTBUS_PCMCIA	equ	6
RMAS_HOSTBUS_PARALLEL	equ	7
RMAS_HOSTBUS_PLANAR	equ	8
RMAS_HOSTBUS_UNKNOWN	equ	255

; resource types

RESTYPE_IO		equ	1
RESTYPE_IRQ		equ	2
RESTYPE_MEM		equ	3

; resource flags

RESFLAG_EXCLUSIVE	equ	1
RESFLAG_MULTIPLEXED   	equ	2
RESFLAG_SHARED        	equ	4
RESFLAG_RECONFIGURE   	equ	8
RESFLAG_GRANT_YIELD   	equ	16


; I/O resource

IORESSTRUCT	STRUC
IORES_ResourceType	DD	?
IORES_BaseIOPort	DW	?
IORES_NumIOPorts	DW	?
IORES_IOFlags		DW	?
IORES_IOAddressLines	DW	?
IORES_Padding		DD	?
IORES_Reserved2		DD	?
IORESSTRUCT	ENDS

; IRQ resource

IRQRESSTRUCT	STRUC
IRQRES_ResourceType	DD	?
IRQRES_IRQLevel		DW	?
IRQRES_PCIIrqPin	DW	?
IRQRES_IRQFlags		DW	?
IRQRES_Reserved		DW	?
IRQRES_pfnIntHandler	DD	?
IRQRES_Reserved2	DD	?
IRQRESSTRUCT	ENDS

; MEM resource

MEMRESSTRUCT	STRUC
MEMRES_ResourceType	DD	?
MEMRES_MemBase		DD	?
MEMRES_MemSize		DD	?
MEMRES_MemFlags		DW	?
MEMRES_ReservedAlign	DW	?
MEMRES_Reserved2	DD	?
MEMRESSTRUCT	ENDS


IORES_SIZE		equ	size IORESSTRUCT
IRQRES_SIZE		equ	size IRQRESSTRUCT
MEMRES_SIZE		equ	size MEMRESSTRUCT


